# Les dimensions sont en millimetres


X0 = 7
Y0 = 7
Zf0 = 3.0


DeltaX = 12
DeltaY = 12
DeltaZ = 0.5

Xstart = X0
Ystart = Y0
Zstart = Zf0

power = 50


# Parametre carre
dlaser = 0.25
cote = 10



def carre(power, speed, Xstart, Ystart):
    nbligne = int(cote / dlaser)
    
    Xend = Xstart + cote - dlaser / 2
    Xstart += dlaser / 2
    Ystart += dlaser / 2
    
    fpower = power / 100.0
    
    print ('power : ', power, ' fpower : ', fpower)
    
    X = Xstart
    Y = Ystart + dlaser / 2
    
    gcodec = "(motif " + str(power) + " / " + str(speed) + ")\n"
    gcodec += "G00 X" + str(round(Xstart, 3)) + " Y" + str(round(Ystart, 3)) + "\n"
    
    for ligne in range(nbligne):
        #print('ligne : ', ligne)
        if (X == Xstart) :
            X = Xend
        else:
            X = Xstart
        gcodec += "G01 X" + str(round(X, 3)) + " F" + str(speed) + " S" + str(fpower) + "\n"
        Y += dlaser
        #gcodec += "G01 Y" + str(round(Y, 3)) + "\n"
        gcodec += "G00 Y" + str(round(Y, 3)) + "\n"
    return gcodec

Zf = Zstart

gcode = "G90\nG92 X0 Y0 Z0\nG21\nG0 Z" + str(round(Zf,2)) + " F5000\n\n(calque : raster) \n"


for focal in range(0, 9):
    print('focal : ', Zf)
    gcode += "\n(focal)\n"
    gcode += "G00 Z" + str(round(Zf, 3)) + "\n"
    Xstart = X0
    for speed in range(500, 3750, 250):
        #print(' speed : ', speed)
        #print(' Xstart : ', Xstart, ' Ystart : ', Ystart)
        gcode += carre(power, speed, Xstart, Ystart)
        Xstart += DeltaX
    Ystart += DeltaY
    Zf += DeltaZ
gcode += "\n"

gcode += "G00 Z" + str(round(Zf0, 3)) + "\n"

file = open("Fin.gcode","r")
gcodefin = file.read()
file.close()

file = open("testfile-ZS.gcode","w")
file.write(gcode)
file.write(gcodefin)
file.close()
